[gmail](mailto:rocksynth@gmail.com) | [facebook](https://www.facebook.com/100009001120071) | [twitter](https://twitter.com/rocksynth) | [linkedin](https://www.linkedin.com/in/colton-colcleasure-73732293) | [medium](https://medium.com/@rocksynth)


### *Not yet a functional application. **Stay tuned.***

# **ntm** | npm[**scripts**] with a makeover.



## **ntm** has access to each of npm's 280,000 packages, introduces beautiful and friendly syntax, and simplifies all of your tasks.


Many respectable web developers vouch for npm as a build tool and task runner. Yet, none of them are afraid to to admit that declaring tasks inside of your package.json is far from appealing and can quickly become a nightmare to navigate.

- [Give Grunt the Boot](http://www.sitepoint.com/guide-to-npm-as-a-build-tool/)	
- [Introduction to Using NPM as a Build Tool](https://medium.com/@dabit3/introduction-to-using-npm-as-a-build-tool-b41076f488b0)
- [Why npm Scripts?](https://css-tricks.com/why-npm-scripts/)
- [Using npm as a Build Tool for Your Next Project](https://drublic.de/blog/npm-builds/)
- [NPM as a Build Tool](http://clickherelabs.com/2016/03/npm-as-a-build-tool/)
- [Yo dawg, I heard you like build tools...](http://amsul.ca/2015/11/06/yo-dawg-i-heard-you-like-build-tools/)

# Enter ntm
ntm is a simple 'language' that compiles to common npm scripts and makes building and tasking a breeze. With keywords, references, and the ability to specify whether your tasks will be run concurrent or in an ordered manner, ntm makes up for its simplicity in funcationality.


![ntm SIMPLE TASK](http://s31.postimg.org/8j3f9mfln/cob.png)    


```
$ node ntm -test compile-babel

npm run babel ./src/babel/*.es6.js ./dist/js/ && concat ./dist/js/ && uglify ./dist/js/ && watch ./src/babel/*.es6.js
```


## Keywords
- `and`, `while`, and `++` are used to specify a concurrent job.

- `next`, `then`, and `>>` are used to specify a chained job.

- `it`, `them`, `dir`, and `files` are 'variables' that refer to the most recently seen path.

- `origin` and `origins` refer to the first path in the task block, and an array of paths that are the first on their lines, respectively.

- *Unrecognized words are ignored.*

# The heart and soul of **ntm** is **npm**.

ntm is npm, and that is all there is to it. Calling `ntm task-name` in the terminal is ultimately calling `npm script-name`. The only difference is the place you define your tasks, how beautiful and dynamic the tasks can be, and the swapping of a 'p' for a 't' in the terminal.